%global	rubyabi	1.8

%global	repoid		71867
%global	majorver	0.10.4
%global	preminorver	rc1

%global	mainrel	3

%global	gemdir		%(ruby -rubygems -e 'puts Gem::dir' 2>/dev/null)
%global	gemname	ruby-debug
%global	geminstdir	%{gemdir}/gems/%{gemname}-%{majorver}%{?preminorver}

%global	rubyabi	1.8

Summary:	Command line interface (CLI) for ruby-debug-base
Name:		rubygem-%{gemname}
Version:	%{majorver}
Release:	%{?preminorver:0.}%{mainrel}%{?preminorver:.%preminorver}%{?dist}
Group:		Development/Languages
License:	BSD
URL:		http://rubyforge.org/projects/ruby-debug/
#Source0:	http://rubygems.org/gems/%%{gemname}-%%{version}.gem
# rc release not hosted on rubygems.org yet, using rubyforge.org site
# Also gem is not released for rc version, so for now using tar ball
Source0:	http://rubyforge.org/frs/download.php/%{repoid}/%{gemname}-%{majorver}%{?preminorver}.tgz
# Use system wide ruby-debug-base
Patch0:	ruby-debug-0.10.4rc1-use-system-base-gem.patch
# Fix test failure
Patch1:	ruby-debug-0.10.4rc1-tast-failure.patch
# Patch from trunk: fix shebang
Patch2:	ruby-debug-0.10.4-rc1-rev948-shebang-misspell.patch

Requires:	ruby(abi) = %{rubyabi}
Requires:	rubygem(columnize)
Requires:	rubygem(ruby-debug-base)
BuildRequires:	ruby(abi) = %{rubyabi}
BuildRequires:	rubygems
BuildRequires(check):	rubygem(columnize)
BuildRequires(check):	rubygem(rake)
BuildRequires(check):	rubygem(ruby-debug-base)

Provides:	rubygem(%{gemname}) = %{version}-%{release}
BuildArch:	noarch

%description
ruby-debug is a fast implementation of the standard debugger debug.rb.
The faster execution speed is achieved by utilizing a new hook in the
Ruby C API.

This package contains a generic command line interface for ruby-debug-base.

%package	doc
Summary:	Documentation for %{name}
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description	doc
This package contains documentation for %{name}.

%prep
##%setup -q -c -T
%setup -q -c -T -a 0

# As rc version of gem is not released yet, now creating gem from tarball
pushd %{gemname}-%{majorver}%{?preminorver}/
## No backup
%patch0 -p1
%patch1 -p1
%patch2 -p0
rake --verbose pkg/ruby-debug-%{majorver}%{?preminorver}.gem
popd

mkdir -p .%{gemdir}
gem install \
	--local \
	--install-dir .%{gemdir} \
	--force \
	--rdoc \
	-V \
%if 0
	%{SOURCE0}
%else
	%{gemname}-%{majorver}%{?preminorver}/pkg/ruby-debug-%{majorver}%{?preminorver}.gem
%endif

# rpmlint issue / cleanups
chmod 0644 .%{gemdir}/cache/*.gem
rm -f .%{geminstdir}/.require_paths

# Remaining rpmlint issue
# Removing shebangs on non-executable files in test/ breaks test, so not fixing this
# Also zero-length files are needed for test

%build

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{gemdir}
cp -a .%{gemdir}/* \
	%{buildroot}%{gemdir}/

# bindir
mkdir -p %{buildroot}/%{_bindir}
mv %{buildroot}%{gemdir}/bin/* %{buildroot}/%{_bindir}/
rmdir %{buildroot}%{gemdir}/bin
find %{buildroot}%{geminstdir}/bin -type f | xargs chmod a+x

%clean
rm -rf %{buildroot}

%check
pushd .%{geminstdir}
rake test --verbose --trace
popd

%files
%defattr(-,root,root,-)
%{_bindir}/rdebug

%dir	%{geminstdir}
%doc	%{geminstdir}/[A-Z]*
%exclude	%{geminstdir}/Rakefile
%{geminstdir}/bin/
%{geminstdir}/cli/
%{gemdir}/cache/%{gemname}-%{majorver}%{?preminorver}.gem
%{gemdir}/specifications/%{gemname}-%{majorver}%{?preminorver}.gemspec


%files	doc
%defattr(-,root,root,-)
%{gemdir}/doc/%{gemname}-%{majorver}%{?preminorver}/
%{geminstdir}/Rakefile
%{geminstdir}/rdbg.rb
%{geminstdir}/doc/
%{geminstdir}/test/

%changelog
* Mon Sep 13 2010  Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.10.4-0.3.rc1
- Fix shebang

* Thu Sep 09 2010  Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.10.4-0.2.rc1
- release++

* Mon Sep 06 2010  Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.10.4-0.1.rc1
- 0.10.4 rc1
- Using rubyforge.org hosted tarball for now, recreating gem from tarball

* Mon Sep 06 2010  Mamoru Tasaka <mtasaka@ioa.s.u-tokyo.ac.jp> - 0.10.3-1
- Initial package


